diff --git a/pithos-macos/PithosActivityFacility.h b/pithos-macos/PithosActivityFacility.h
index 912f246..fd0cd60 100644
--- a/pithos-macos/PithosActivityFacility.h
+++ b/pithos-macos/PithosActivityFacility.h
@@ -2,7 +2,7 @@
 //  PithosActivityFacility.h
 //  pithos-macos
 //
-// Copyright 2011 GRNET S.A. All rights reserved.
+// Copyright 2011-2012 GRNET S.A. All rights reserved.
 //
 // Redistribution and use in source and binary forms, with or
 // without modification, are permitted provided that the following
@@ -37,6 +37,7 @@
 
 #import <Foundation/Foundation.h>
 #import "PithosActivity.h"
+@class PithosAccount;
 
 @protocol PithosActivityFacilityDelegate <NSObject>
 @required
@@ -62,13 +63,21 @@
 + (id)defaultPithosActivityFacility;
 
 - (void)reset;
+
 - (PithosActivity *)startActivityWithType:(PithosActivityType)type 
                                   message:(NSString *)message 
                                totalBytes:(NSUInteger)totalBytes 
-                             currentBytes:(NSUInteger)currentBytes;
+                             currentBytes:(NSUInteger)currentBytes 
+                            pithosAccount:(PithosAccount *)pithosAccount;
 - (PithosActivity *)startActivityWithType:(PithosActivityType)type 
-                                  message:(NSString *)message;
+                                  message:(NSString *)message 
+                               totalBytes:(NSUInteger)totalBytes 
+                             currentBytes:(NSUInteger)currentBytes;
+- (PithosActivity *)startActivityWithType:(PithosActivityType)type message:(NSString *)message pithosAccount:(PithosAccount *)pithosAccount;
+- (PithosActivity *)startActivityWithType:(PithosActivityType)type message:(NSString *)message;
+- (PithosActivity *)startAndEndActivityWithType:(PithosActivityType)type message:(NSString *)message pithosAccount:(PithosAccount *)pithosAccount;
 - (PithosActivity *)startAndEndActivityWithType:(PithosActivityType)type message:(NSString *)message;
+
 - (void)updateActivity:(PithosActivity *)activity 
            withMessage:(NSString *)message 
             totalBytes:(NSUInteger)totalBytes 
diff --git a/pithos-macos/PithosActivityFacility.m b/pithos-macos/PithosActivityFacility.m
index 7078b21..92e2fa3 100644
--- a/pithos-macos/PithosActivityFacility.m
+++ b/pithos-macos/PithosActivityFacility.m
@@ -2,7 +2,7 @@
 //  PithosActivityFacility.m
 //  pithos-macos
 //
-// Copyright 2011 GRNET S.A. All rights reserved.
+// Copyright 2011-2012 GRNET S.A. All rights reserved.
 //
 // Redistribution and use in source and binary forms, with or
 // without modification, are permitted provided that the following
@@ -36,6 +36,7 @@
 // or implied, of GRNET S.A.
 
 #import "PithosActivityFacility.h"
+#import "PithosAccount.h"
 
 static PithosActivityFacility *defaultPithosActivityFacility = nil;
 
@@ -172,8 +173,12 @@ static PithosActivityFacility *defaultPithosActivityFacility = nil;
             }
             pickedRunning = YES;
         }
-        if (activity && activity.message)
-            [info setObject:activity.message forKey:@"message"];
+        if (activity && activity.message) {
+            if (activity.pithosAccount)
+                [info setObject:[NSString stringWithFormat:@"[%@] %@", activity.pithosAccount.name, activity.message] forKey:@"message"];
+            else
+                [info setObject:activity.message forKey:@"message"];
+        }
         [info setObject:[NSNumber numberWithUnsignedInteger:[runningActivities count]] forKey:@"runningActivitiesCount"];
         [info setObject:[NSNumber numberWithUnsignedInteger:[endingActivities count]] forKey:@"endingActivitiesCount"];
         [info setObject:[NSNumber numberWithUnsignedInteger:totalUploadBytes] forKey:@"totalUploadBytes"];
@@ -193,8 +198,9 @@ static PithosActivityFacility *defaultPithosActivityFacility = nil;
 - (PithosActivity *)startActivityWithType:(PithosActivityType)type 
                                   message:(NSString *)message 
                                totalBytes:(NSUInteger)totalBytes 
-                               currentBytes:(NSUInteger)currentBytes {
-    PithosActivity *activity = [[[PithosActivity alloc] initWithType:type] autorelease];
+                             currentBytes:(NSUInteger)currentBytes 
+                            pithosAccount:(PithosAccount *)pithosAccount {
+    PithosActivity *activity = [[[PithosActivity alloc] initWithType:type pithosAccount:pithosAccount] autorelease];
     activity.message = message;
     activity.totalBytes = totalBytes;
     activity.currentBytes = currentBytes;
@@ -226,12 +232,27 @@ static PithosActivityFacility *defaultPithosActivityFacility = nil;
 }
 
 - (PithosActivity *)startActivityWithType:(PithosActivityType)type 
+                                  message:(NSString *)message 
+                               totalBytes:(NSUInteger)totalBytes 
+                             currentBytes:(NSUInteger)currentBytes {
+    return [self startActivityWithType:type message:message totalBytes:totalBytes currentBytes:currentBytes pithosAccount:nil];
+}
+
+- (PithosActivity *)startActivityWithType:(PithosActivityType)type 
+                                  message:(NSString *)message 
+                            pithosAccount:(PithosAccount *)pithosAccount {
+    return [self startActivityWithType:type message:message totalBytes:0 currentBytes:0 pithosAccount:pithosAccount];
+}
+
+- (PithosActivity *)startActivityWithType:(PithosActivityType)type 
                                   message:(NSString *)message {
-    return [self startActivityWithType:type message:message totalBytes:0 currentBytes:0];
+    return [self startActivityWithType:type message:message pithosAccount:nil];
 }
 
-- (PithosActivity *)startAndEndActivityWithType:(PithosActivityType)type message:(NSString *)message {
-    PithosActivity *activity = [[[PithosActivity alloc] initWithType:type] autorelease];
+- (PithosActivity *)startAndEndActivityWithType:(PithosActivityType)type 
+                                        message:(NSString *)message 
+                                  pithosAccount:(PithosAccount *)pithosAccount {
+    PithosActivity *activity = [[[PithosActivity alloc] initWithType:type pithosAccount:pithosAccount] autorelease];
     activity.message = message;
     activity.totalBytes = 0;
     activity.currentBytes = 0;
@@ -243,6 +264,10 @@ static PithosActivityFacility *defaultPithosActivityFacility = nil;
     return activity;
 }
 
+- (PithosActivity *)startAndEndActivityWithType:(PithosActivityType)type message:(NSString *)message {
+    return [self startAndEndActivityWithType:type message:message pithosAccount:nil];
+}
+
 - (void)updateActivity:(PithosActivity *)activity 
            withMessage:(NSString *)message 
             totalBytes:(NSUInteger)totalBytes 
diff --git a/pithos-macos/PithosBrowserController.h b/pithos-macos/PithosBrowserController.h
index eef7575..145eb52 100644
--- a/pithos-macos/PithosBrowserController.h
+++ b/pithos-macos/PithosBrowserController.h
@@ -47,6 +47,7 @@
 
 @interface PithosBrowserController : NSWindowController <NSBrowserDelegate, NSSplitViewDelegate, NSOutlineViewDelegate, NSOutlineViewDataSource, NSMenuDelegate, PithosActivityFacilityDelegate> {
     BOOL browserInitialized;
+    BOOL browserActive;
     
     ASIPithos *pithos;
     
@@ -87,11 +88,16 @@
     ASINetworkQueue *deleteNetworkQueue;
     ASINetworkQueue *uploadNetworkQueue;
     ASINetworkQueue *downloadNetworkQueue;
-    dispatch_queue_t moveQueue;
-    dispatch_queue_t copyQueue;
-    dispatch_queue_t deleteQueue;
-    dispatch_queue_t uploadQueue;
-    dispatch_queue_t downloadQueue;
+    NSOperationQueue *moveQueue;
+    NSOperationQueue *copyQueue;
+    NSOperationQueue *deleteQueue;
+    NSOperationQueue *uploadQueue;
+    NSOperationQueue *downloadQueue;
+    NSOperationQueue *moveCallbackQueue;
+    NSOperationQueue *copyCallbackQueue;
+    NSOperationQueue *deleteCallbackQueue;
+    NSOperationQueue *uploadCallbackQueue;
+    NSOperationQueue *downloadCallbackQueue;
 }
 
 @property (nonatomic, retain) ASIPithos *pithos;
@@ -119,5 +125,8 @@
 
 - (IBAction)forceRefresh:(id)sender;
 - (IBAction)refresh:(id)sender;
+- (void)resetBrowser;
+- (void)startBrowser;
+- (BOOL)operationsPending;
 
 @end
